unit Clock;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TTypeBoardCharacterHour=(bchNone,bchNoon,bchFour,bchAll);     //Ղ̕[]\̌^ bchNone:Ȃ; bchNoon:12; bchFore:12,3,6,9; bchAll:ׂĂ
  TTypeBoardCharacterHourAssist=(bchaHide,bchaShow);             //Ղ̕[]⏕̕\̌^ bchaHide:Ȃ,bchaShow:
  TTypeBoardCharacterMinute=(bcmNone,bcmFour,bcmTwelve,bcmAll);   //Ղ̕[]\̌^ bcmNone:Ȃ; bcmFore:12,3,6,9̂Ƃ낾; bcmTwelve:êƂ낾; bcmAll:ׂĂ
  TTypeBoardScale=(bsNone,bsNoon,bsFour,bsTwelve,bsAll);//Ղ̍ݕ\̌^ bsNone:݂Ȃ,bsNoon:12̂Ƃ낾; bsFour:3,6,9,12̂Ƃ낾; bsTwelve:êƂ낾; bsAll:ׂĂ
  TTypeShowHandSecond=(shsShow,shsHide);                //bj\̌^ ssShow:bjȂ; ssHide:bj
  TTypeDividedColor=(dcYes,dcNo);                       //敪Fȟ^ dcYes:; dcNo:Ȃ
  TTypeHandsShape=(hsRound,hsSharp);                    //j`̌^ nsRound:; nsSharp:
  TTypeHandsBrush=(hbClear,hbSolid);                    //jhԂ̌^ hbClear; ; hbSolid:hԂ

  TClock = class(TCustomControl)
  private
    { Private 錾 }
    RatioMinute,RatioHour: real;                                      //ǰ`󂪌̂ƂAjAj̒̊iwidth/2Ƃ̔j
    px10,py10,px20,py20,px30,py30,px40,py40,px50,py50:integer;        //`󂪌̂Ƃ̍Wijj
    px11,py11,px21,py21,px31,py31,px41,py41,px51,py51:integer;        //`󂪌̂Ƃ̍Wijj
    rInner,rOuter: real;                                              //ڐ̓Oa
    rHour,rMinute,rSecond: real;                                      //jAjAbj̒̊iwidth/2Ƃ̔j
    sx,sy: real;                                                      //R|[lg̒SWƕՂ̒aƂ̍
    FWidthBorderLine: byte;                                           //E̕
    FWidthScaleNoon: byte;                                            //߂̐̕
    FWidthScale1Minutes: byte;                                        //P̐̕
    FWidthScale5Minutes: byte;                                        //T̐̕
    FWidthHandHour: byte;                                             //j̕
    FWidthHandMinute: byte;                                           //j̕
    FWidthHandSecond: byte;                                           //bj̕
    ValueTextRect: TRect;                                             //Positionl̕`̈
    ValueText:string;                                                //Positionl̓e
    FBoardFontSizeHour: byte;                                         //Ղ̕[]̃tHgTCY
    FBoardFontSizeMinute: byte;                                       //Ղ̕[]̃tHgTCY
    FBoardColor: TColor;                                              //Ղ̐F
    FTypeBoardCharacterHour: TTypeBoardCharacterHour;                 //Ղ̕[]\̌^
    FTypeBoardCharacterHourAssist: TTypeBoardCharacterHourAssist;     //Ղ̕[]⏕̕\̌^
    FTypeBoardCharacterMinute: TTypeBoardCharacterMinute;             //Ղ̕[]\̌^
    FTypeBoardScale:     TTypeBoardScale;                             //Ղ̍ݕ\̌^
    FTypeShowHandSecond: TTypeShowHandSecond;                         //bj\̌^
    FTypeDividedColor:   TTypeDividedColor;                           //敪Fȟ^
    FTypeHandsShape:     TTypeHandsShape;                             //j`̌^
    FTypeHandsBrush:     TTypeHandsBrush;                             //jhԂ̌^
    FTimeHour: integer;                                               //
    FTimeMinute: integer;                                             //
    FTimeSecond: integer;                                             //b
    FDiameter: integer;                                               //Ղ̒a
    FOnChange: TNotifyEvent;
    function  HalfAdjust(x: Extended): Longint;                       //ľܓ
    function xRotate(x0,y0:integer;t:real):integer;                   //ꎟϊɂ]
    function yRotate(x0,y0:integer;t:real):integer;                   //ꎟϊɂ]
    procedure SetDiameter(const Value: integer);                      //Ղ̒aݒ
    procedure SetBoardFontSizeHour(const Value: byte);                //Ղ̕[]̃tHgTCYݒ
    procedure SetBoardFontSizeMinute(const Value: byte);              //Ղ̕[]̃tHgTCYݒ
    procedure SetBoardColor(const Value: TColor);                     //Ղ̐Fݒ
    procedure SetTimeHour(const Value: Integer);                      //uvݒ
    procedure SetTimeMinute(const Value: Integer);                    //uvݒ
    procedure SetTimeSecond(const Value: Integer);                    //ubvݒ
    procedure SetTypeBoardCharacterHour(const Value: TTypeBoardCharacterHour);//Ղ̕[]\̌^ݒ
    procedure SetTypeBoardCharacterHourAssist(const Value: TTypeBoardCharacterHourAssist);//Ղ̕[]⏕̕\̌^ݒ
    procedure SetTypeBoardCharacterMinute(const Value: TTypeBoardCharacterMinute);//Ղ̕[]\̌^ݒ
    procedure SetTypeBoardScale(const Value: TTypeBoardScale);        //Ղ̍ݕ\̌^ݒ
    procedure SetTypeShowHandSecond(const Value: TTypeShowHandSecond);//bj\̌^ݒ
    procedure SetTypeDividedColor(const Value: TTypeDividedColor);    //敪Fȟ^ݒ
    procedure SetTypeHandsShape(const Value: TTypeHandsShape);        //j`̌^ݒ
    procedure SetTypeHandsBrush(const Value: TTypeHandsBrush);        //jhԂ̌^ݒ
    procedure SetWidthBorderLine(const Value: byte);                  //E̕ݒ
    procedure SetWidthScaleNoon(const Value: byte);                   //߂̐̕ݒ
    procedure SetWidthScale1Minutes(const Value: byte);               //P̐̕ݒ
    procedure SetWidthScale5Minutes(const Value: byte);               //T̐̕ݒ
    procedure SetWidthHandHour(const Value: byte);                    //j̕ݒ
    procedure SetWidthHandMinute(const Value: byte);                  //j̕ݒ
    procedure SetWidthHandSecond(const Value: byte);                  //bj̕ݒ
  protected
    { Protected 錾 }
    procedure Change; virtual; // OnChangeCxg̃CxgfBXpb`
    procedure Paint; override; //`
    procedure Resize;override; //Rg[̃TCYύX
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  published
    { Published 錾 }
    property Color;       // Ղ̔wii~`jF
    property ParentColor; // eRg[F̌p
    property TimeHour: Integer read FTimeHour write SetTimeHour default 0; // j̈ʒu(l)
    property TimeMinute: Integer read FTimeMinute write SetTimeMinute default 0; // j̈ʒu(l)
    property TimeSecond: Integer read FTimeSecond write SetTimeSecond default 0; // bj̈ʒu(l)
    property BoardFontSizeHour: byte read FBoardFontSizeHour write SetBoardFontSizeHour default 13;// Ղ̕[]̃tHgTCY
    property BoardFontSizeMinute: byte read FBoardFontSizeMinute write SetBoardFontSizeMinute default 4;// Ղ̕[]̃tHgTCY
    property BoardColor: TColor read FBoardColor write SetBoardColor default clBtnFace;// Ձi`j̐F
    property TypeBoardCharacterHour: TTypeBoardCharacterHour read FTypeBoardCharacterHour write SetTypeBoardCharacterHour default bchAll;//Ղ̕[]\̌^
    property TypeBoardCharacterHourAssist: TTypeBoardCharacterHourAssist read FTypeBoardCharacterHourAssist write SetTypeBoardCharacterHourAssist default bchaShow;//Ղ̕[]⏕\̌^
    property TypeBoardCharacterMinute: TTypeBoardCharacterMinute read FTypeBoardCharacterMinute write SetTypeBoardCharacterMinute default bcmTwelve;//Ղ̕[]\̌^
    property TypeBoardScale: TTypeBoardScale read FTypeBoardScale write SetTypeBoardScale default bsAll;//Ղ̍ݕ\̌^
    property TypeShowHandSecond: TTypeShowHandSecond read FTypeShowHandSecond write SetTypeShowHandSecond default shsShow;//bj\̌^
    property TypeDividedColor: TTypeDividedColor read FTypeDividedColor write SetTypeDividedColor default dcYes;//敪Fȟ^
    property TypeHandsShape: TTypeHandsShape read FTypeHandsShape write SetTypeHandsShape default hsRound;//j`̌^
    property TypeHandsBrush: TTypeHandsBrush read FTypeHandsBrush write SetTypeHandsBrush default hbSolid;//jhԂ̌^
    property WidthBorderLine: byte read FWidthBorderLine write SetWidthBorderLine default 1;//E̕
    property WidthScale1Minutes: byte read FWidthScale1Minutes write SetWidthScale1Minutes default 1;//P݂̍̕
    property WidthScale5Minutes: byte read FWidthScale5Minutes write SetWidthScale5Minutes default 3;//T݂̍̕
    property WidthScaleNoon: byte read FWidthScaleNoon write SetWidthScaleNoon default 5;            //PQ̂Ƃ̐̕
    property WidthHandHour: byte read FWidthHandHour write SetWidthHandHour default 8;            //j̕
    property WidthHandMinute: byte read FWidthHandMinute write SetWidthHandMinute default 5;      //j̕
    property WidthHandSecond: byte read FWidthHandSecond write SetWidthHandSecond default 1;      //bj̕
    property ShowHint;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property OnClick;
    property Diameter: Integer read FDiameter write SetDiameter default 200; // Ղ̒a
  end;

procedure Register;

implementation

function TClock.HalfAdjust(x: Extended): Longint;
//ľܓ
begin
  if x >= 0 then Result := Trunc(x + 0.5)
  else Result := Trunc(x - 0.5);
end;

//ꎟϊ(]ړ)
function TClock.xRotate(x0,y0:integer;t:real):integer;
begin
  result:= {ceil}HalfAdjust(rOuter-x0*cos(t)+y0*sin(t));
end;

function TClock.yRotate(x0,y0:integer;t:real):integer;
begin
  result:=HalfAdjust(rOuter-x0*sin(t)-y0*cos(t));
end;

procedure Register;
begin
  RegisterComponents('Samples', [TClock]);
end;

constructor TClock.Create(AOwner: TComponent);
// RXgN^
begin
  inherited Create(AOwner);
//ʂ鏔̏
  FDiameter:=200;

  FWidthBorderLine:=1;//HalfAdjust(FDiameter /160);
  FWidthScale1Minutes:=1;//HalfAdjust(FDiameter /160);
  FWidthScale5Minutes:=2;//HalfAdjust(FDiameter /160*2);
  FWidthScaleNoon:=5;//HalfAdjust(FDiameter /160*5);
  FWidthHandHour:=8;//HalfAdjust(FDiameter /160*8);
  FWidthHandMinute:=5;//HalfAdjust(FDiameter /160*5);
  FWidthHandSecond:=1;//HalfAdjust(FDiameter /160);
  FBoardFontSizeHour:= 13;//HalfAdjust(FDiameter /160*13);
  FBoardFontSizeMinute:= 4;//HalfAdjust(FDiameter /160*4);
  Width:=FDiameter+3*FBoardFontSizeMinute;
  Height:=FDiameter+3*FBoardFontSizeMinute;
  sx:=width/2-FDiameter/2;
  sy:=height/2-FDiameter/2;
  FBoardColor:= clBtnFace;
  FTypeBoardCharacterHour:= bchAll;
  FTypeBoardCharacterHourAssist:= bchaShow;
  FTypeBoardCharacterMinute:= bcmTwelve;
  FTypeBoardScale:= bsAll;
  FTypeShowHandSecond:= shsShow;
  FTypeDividedColor:= dcYes;
  FTypeHandsShape:= hsRound;
  FTypeHandsBrush:= hbSolid;
  FTimeHour:=0;
  FTimeMinute:=0;
  FTimeSecond:=0;
  rMinute:=80/100;
  rHour:=60/100;
  rSecond:=70/100;
  RatioMinute:=83/100;
  RatioHour:=65/100;

  // `ɂ̓`cL}邽߃_uobt@g
  DoubleBuffered := True;
end;

procedure TClock.Paint;
//`
var i: integer;
begin
//  inherited;
  FDiameter:=Width-3*FBoardFontSizeMinute;
  sx:=width/2-FDiameter/2;
  sy:=height/2-FDiameter/2;

  rInner:= HalfAdjust(FDiameter / 2 *95/100);
  rOuter:= HalfAdjust(FDiameter / 2);

  //E
  canvas.Pen.Style:= psSolid;
  canvas.Pen.Width:=FWidthBorderLine;
  canvas.Pen.Color:= clBlack;
  Canvas.Brush.Style := bsSolid;
  canvas.Brush.Color:= FBoardColor;
  canvas.Ellipse(halfadjust(sx+canvas.Pen.Width div 2),
                 halfadjust(sy+canvas.Pen.Width div 2),
                 halfadjust(sx+FDiameter-canvas.Pen.Width div 2),
                 halfadjust(sy+FDiameter-canvas.Pen.Width div 2));
  //敪Fh
  if ((FTypeBoardCharacterHour=bchAll) and (FTypeDividedColor=dcYes) and ((TypeBoardScale=bsTwelve) or (TypeBoardScale=bsAll))) then
  begin
    Canvas.Pen.Width:=1;
    Canvas.Pen.Color:= clLtGray;
    canvas.Brush.Color:= clLtGray;
    for i:=0 to 5 do
    begin
      Canvas.pie(HalfAdjust(sx+FWidthBorderLine),
                 HalfAdjust(sy+FWidthBorderLine),
                 HalfAdjust(sx+FDiameter-FWidthBorderLine),
                 HalfAdjust(sy+FDiameter-FWidthBorderLine),
                 HalfAdjust(sx+rOuter*(1-cos((2*i+1)*2*pi/12+pi/2))),
                 HalfAdjust(sy+rOuter*(1-sin((2*i+1)*2*pi/12+pi/2))),
                 HalfAdjust(sx+rOuter*(1-cos( 2*i   *2*pi/12+pi/2))),
                 HalfAdjust(sy+rOuter*(1-sin( 2*i   *2*pi/12+pi/2))));
    end;
  end;

  //XP[i݁j
  //P̐
  Canvas.Pen.Color:= clBlack;
  canvas.Pen.Style:= psSolid;
  canvas.Pen.Width:=WidthScale1Minutes;
  for i:=1 to 59 do
  begin
    if FTypeBoardScale= bsAll then
    begin
      canvas.MoveTo(HalfAdjust(sx+rOuter-(rInner                       )*cos(i*2*pi/60+pi/2)),
                    HalfAdjust(sy+rOuter-(rInner                       )*sin(i*2*pi/60+pi/2)));
      canvas.lineTo(HalfAdjust(sx+rOuter-(rOuter-canvas.Pen.Width div 2)*cos(i*2*pi/60+pi/2)),
                    HalfAdjust(sy+rOuter-(rOuter-canvas.Pen.Width div 2)*sin(i*2*pi/60+pi/2)));
    end;
  end;
  //T̐iP`PPj
  canvas.Pen.Style:= psSolid;
  canvas.Pen.Width:=WidthScale5Minutes;
  for i:=1 to 11 do
  begin
    if ((FTypeBoardScale=bsTwelve) or (FTypeBoardScale=bsFour) or (FTypeBoardScale=bsAll)) then
    begin
      if ((FTypeBoardScale=bsTwelve) or (FTypeBoardScale=bsAll)) then
      begin
        canvas.MoveTo(HalfAdjust(sx+rOuter-(rInner                       )*cos(i*2*pi/12+pi/2)),
                      HalfAdjust(sy+rOuter-(rInner                       )*sin(i*2*pi/12+pi/2)));
        canvas.lineTo(HalfAdjust(sx+rOuter-(rOuter-canvas.Pen.Width div 2)*cos(i*2*pi/12+pi/2)),
                      HalfAdjust(sy+rOuter-(rOuter-canvas.Pen.Width div 2)*sin(i*2*pi/12+pi/2)));
      end;
      if ((FTypeBoardScale=bsFour) and ((i mod 3)=0)) then
      begin
        canvas.MoveTo(HalfAdjust(sx+rOuter-(rInner                       )*cos(i*2*pi/12+pi/2)),
                      HalfAdjust(sy+rOuter-(rInner                       )*sin(i*2*pi/12+pi/2)));
        canvas.lineTo(HalfAdjust(sx+rOuter-(rOuter-canvas.Pen.Width div 2)*cos(i*2*pi/12+pi/2)),
                      HalfAdjust(sy+rOuter-(rOuter-canvas.Pen.Width div 2)*sin(i*2*pi/12+pi/2)));
      end;
    end;
  end;
  //߁iPQj
  canvas.Pen.Style:= psSolid;
  canvas.Pen.Width:=WidthScaleNoon;
  if FTypeBoardScale<>bsNone then
  begin
    canvas.MoveTo(  HalfAdjust(sx+rOuter-(rInner                       )*cos(0*2*pi/12+pi/2)),
                    HalfAdjust(sy+rOuter-(rInner                       )*sin(0*2*pi/12+pi/2)));
    canvas.lineTo(  HalfAdjust(sx+rOuter-(rOuter-canvas.Pen.Width div 2)*cos(0*2*pi/12+pi/2)),
                    HalfAdjust(sy+rOuter-(rOuter-canvas.Pen.Width div 2)*sin(0*2*pi/12+pi/2)));
  end;


  // Ղ̕[]⏕
  canvas.Pen.Color:= clBlack;
  canvas.Pen.Style:= psSolid;
  Canvas.Brush.Style := bsclear;
  Canvas.Font.size:= halfadjust(FBoardFontSizeHour/2);
  if ((FTypeBoardCharacterHour=bchAll) and (FTypeDividedColor=dcYes) and ((TypeBoardScale=bsTwelve) or (TypeBoardScale=bsAll))) then
  begin
    for i:=1 to 12 do
    begin
      if i mod 2=0 then Canvas.Font.Color := clWhite
                   else Canvas.Font.Color := clGray;

      ValueText := inttostr(i);
      //̈ݒ肷
      ValueTextRect := Rect(HalfAdjust(sx+rOuter-(rInner/8*7-FBoardFontSizeHour*5/6)*cos(i*pi/6+pi/2+pi/12)-FBoardFontSizeHour*23/24),
                            HalfAdjust(sy+rOuter-(rInner/8*7-FBoardFontSizeHour*5/6)*sin(i*pi/6+pi/2+pi/12)-FBoardFontSizeHour*1/3),
                            HalfAdjust(sx+rOuter-(rInner/8*7-FBoardFontSizeHour*5/6)*cos(i*pi/6+pi/2+pi/12)+FBoardFontSizeHour*25/24),
                            HalfAdjust(sy+rOuter-(rInner/8*7-FBoardFontSizeHour*5/6)*sin(i*pi/6+pi/2+pi/12)+FBoardFontSizeHour*3/3));
      case FTypeBoardCharacterHourAssist of
        bchaHide :begin end;
        bchaShow  :DrawText(Canvas.Handle, PChar(ValueText), -1, ValueTextRect, DT_CENTER or DT_SINGLELINE);
      end;
    end;
  end;
  
  //j
  canvas.Pen.Style:= psSolid;
  canvas.Pen.Color:= clRed;
  case FTypeHandsShape of
    hsRound:
      begin
        px10:=HalfAdjust( (widthHandHour-widthBorderLine)/2) ;py10:=0;
        px20:=HalfAdjust( (widthHandHour-widthBorderLine)/2) ;py20:=HalfAdjust(rOuter*RatioHour-sqrt(1/2)*(widthHandHour-widthBorderLine));
        px30:=0                                              ;py30:=HalfAdjust(rOuter*RatioHour-sqrt(1/2)*(widthHandHour-widthBorderLine));
        px40:=HalfAdjust(-(widthHandHour-widthBorderLine)/2) ;py40:=HalfAdjust(rOuter*RatioHour-sqrt(1/2)*(widthHandHour-widthBorderLine));
        px50:=HalfAdjust(-(widthHandHour-widthBorderLine)/2) ;py50:=0;

        px11:=xRotate(px10,py10,((FTimehour+FTimeMinute/60+FTimeSecond/3600)*pi/6)); py11:=yRotate(px10,py10,((FTimeHour+FTimeMinute/60+FTimeSecond/3600)*pi/6));
        px21:=xRotate(px20,py20,((FTimehour+FTimeMinute/60+FTimeSecond/3600)*pi/6)); py21:=yRotate(px20,py20,((FTimeHour+FTimeMinute/60+FTimeSecond/3600)*pi/6));
        px31:=xRotate(px30,py30,((FTimehour+FTimeMinute/60+FTimeSecond/3600)*pi/6)); py31:=yRotate(px30,py30,((FTimeHour+FTimeMinute/60+FTimeSecond/3600)*pi/6));
        px41:=xRotate(px40,py40,((FTimehour+FTimeMinute/60+FTimeSecond/3600)*pi/6)); py41:=yRotate(px40,py40,((FTimeHour+FTimeMinute/60+FTimeSecond/3600)*pi/6));
        px51:=xRotate(px50,py50,((FTimehour+FTimeMinute/60+FTimeSecond/3600)*pi/6)); py51:=yRotate(px50,py50,((FTimeHour+FTimeMinute/60+FTimeSecond/3600)*pi/6));

        Canvas.Pen.Width:= FWidthBorderLine;
        Canvas.Brush.style := bsSolid;
        if FTypeHandsBrush= hbSolid then
        begin
          Canvas.Brush.Color :=clRed;
          canvas.pie(HalfAdjust(sx+rOuter-(widthHandHour-widthBorderLine)/2),
                     HalfAdjust(sy+rOuter-(widthHandHour-widthBorderLine)/2),
                     HalfAdjust(sx+rOuter+(widthHandHour-widthBorderLine)/2),
                     HalfAdjust(sy+rOuter+(widthHandHour-widthBorderLine)/2),
                     HalfAdjust(sx+px11),
                     Halfadjust(sy+py11),
                     Halfadjust(sx+px51),
                     Halfadjust(sy+py51));
          Canvas.Polygon([Point(Halfadjust(sx+px11),Halfadjust(sy+py11)),
                          Point(Halfadjust(sx+px21),Halfadjust(sy+py21)),
                          Point(Halfadjust(sx+px41),Halfadjust(sy+py41)),
                          Point(Halfadjust(sx+px51),Halfadjust(sy+py51))]);
          canvas.pie(HalfAdjust(sx+px31-(widthHandHour-widthBorderLine)/2),
                     HalfAdjust(sy+py31-(widthHandHour-widthBorderLine)/2),
                     HalfAdjust(sx+px31+(widthHandHour-widthBorderLine)/2),
                     HalfAdjust(sy+py31+(widthHandHour-widthBorderLine)/2),
                     Halfadjust(sx+px41),
                     Halfadjust(sy+py41),
                     Halfadjust(sx+px21),
                     Halfadjust(sy+py21));
        end;
        if FTypeHandsBrush=hbClear then
        begin
          canvas.Arc(HalfAdjust(sx+rOuter-(widthHandHour-widthBorderLine)/2),
                     HalfAdjust(sy+rOuter-(widthHandHour-widthBorderLine)/2),
                     HalfAdjust(sx+rOuter+(widthHandHour-widthBorderLine)/2),
                     HalfAdjust(sy+rOuter+(widthHandHour-widthBorderLine)/2),
                     Halfadjust(sx+px11),
                     Halfadjust(sy+py11),
                     Halfadjust(sx+px51),
                     Halfadjust(sy+py51));
          Canvas.moveto(Halfadjust(sx+px11),Halfadjust(sy+py11));
          canvas.lineto(Halfadjust(sx+px21),Halfadjust(sy+py21));
          canvas.Arc(HalfAdjust(sx+px31-(widthHandHour-widthBorderLine)/2),
                     HalfAdjust(sy+py31-(widthHandHour-widthBorderLine)/2),
                     HalfAdjust(sx+px31+(widthHandHour-widthBorderLine)/2),
                     HalfAdjust(sy+py31+(widthHandHour-widthBorderLine)/2),
                     Halfadjust(sx+px41),
                     Halfadjust(sy+py41),
                     Halfadjust(sx+px21),
                     Halfadjust(sy+py21));
          canvas.moveto(Halfadjust(sx+px41),Halfadjust(sy+py41));
          canvas.LineTo(Halfadjust(sx+px51),Halfadjust(sy+py51));
        end;
      end;
    hsSharp:
      begin
        px10:=HalfAdjust( (widthHandHour-widthBorderLine)/2) ;py10:=HalfAdjust(-(widthHandHour-widthBorderLine)/2);
        px20:=HalfAdjust( (widthHandHour-widthBorderLine)/2) ;py20:=HalfAdjust(rOuter*RatioHour-sqrt(1/2)*(widthHandHour-widthBorderLine));
        px30:=0                                              ;py30:=HalfAdjust(rOuter*RatioHour);
        px40:=HalfAdjust(-(widthHandHour-widthBorderLine)/2) ;py40:=HalfAdjust(rOuter*RatioHour-sqrt(1/2)*(widthHandHour-widthBorderLine));
        px50:=HalfAdjust(-(widthHandHour-widthBorderLine)/2) ;py50:=HalfAdjust(-(widthHandHour-widthBorderLine)/2);

        px11:=xRotate(px10,py10,((FTimehour+FTimeMinute/60+FTimeSecond/3600)*pi/6)); py11:=yRotate(px10,py10,((FTimeHour+FTimeMinute/60+FTimeSecond/3600)*pi/6));
        px21:=xRotate(px20,py20,((FTimehour+FTimeMinute/60+FTimeSecond/3600)*pi/6)); py21:=yRotate(px20,py20,((FTimeHour+FTimeMinute/60+FTimeSecond/3600)*pi/6));
        px31:=xRotate(px30,py30,((FTimehour+FTimeMinute/60+FTimeSecond/3600)*pi/6)); py31:=yRotate(px30,py30,((FTimeHour+FTimeMinute/60+FTimeSecond/3600)*pi/6));
        px41:=xRotate(px40,py40,((FTimehour+FTimeMinute/60+FTimeSecond/3600)*pi/6)); py41:=yRotate(px40,py40,((FTimeHour+FTimeMinute/60+FTimeSecond/3600)*pi/6));
        px51:=xRotate(px50,py50,((FTimehour+FTimeMinute/60+FTimeSecond/3600)*pi/6)); py51:=yRotate(px50,py50,((FTimeHour+FTimeMinute/60+FTimeSecond/3600)*pi/6));

        Canvas.Pen.Width:= FWidthBorderLine;
        Canvas.Brush.style := bsSolid;
        if FTypeHandsBrush=hbSolid then
        begin
          Canvas.Brush.Color :=clRed;
          Canvas.Polygon([Point(Halfadjust(sx+px11),Halfadjust(sy+py11)),
                          Point(Halfadjust(sx+px21),Halfadjust(sy+py21)),
                          Point(Halfadjust(sx+px31),Halfadjust(sy+py31)),
                          Point(Halfadjust(sx+px41),Halfadjust(sy+py41)),
                          Point(Halfadjust(sy+px51),Halfadjust(sy+py51))]);
        end;
        if FTypeHandsBrush=hbClear then
        begin
          Canvas.Polygon([Point(Halfadjust(sx+px11),Halfadjust(sy+py11)),
                          Point(Halfadjust(sx+px21),Halfadjust(sy+py21)),
                          Point(Halfadjust(sx+px31),Halfadjust(sy+py31)),
                          Point(Halfadjust(sx+px41),Halfadjust(sy+py41)),
                          Point(Halfadjust(sx+px51),Halfadjust(sy+py51))]);
        end;
      end;
  end;

  //j
  canvas.Pen.Color:= clBlack;
  case FTypeHandsShape of
    hsRound:
      begin
        px10:=HalfAdjust( (widthHandMinute-widthBorderLine)/2) ;py10:=0;
        px20:=HalfAdjust( (widthHandMinute-widthBorderLine)/2) ;py20:=HalfAdjust(rOuter*RatioMinute-sqrt(1/2)*(widthHandMinute-widthBorderLine));
        px30:=0                                                ;py30:=HalfAdjust(rOuter*RatioMinute-sqrt(1/2)*(widthHandMinute-widthBorderLine));
        px40:=HalfAdjust(-(widthHandMinute-widthBorderLine)/2) ;py40:=HalfAdjust(rOuter*RatioMinute-sqrt(1/2)*(widthHandMinute-widthBorderLine));
        px50:=HalfAdjust(-(widthHandMinute-widthBorderLine)/2) ;py50:=0;

        px11:=xRotate(px10,py10,((FTimeMinute+FTimeSecond/60)/5*pi/6)); py11:=yRotate(px10,py10,((FTimeMinute+FTimeSecond/60)/5*pi/6));
        px21:=xRotate(px20,py20,((FTimeMinute+FTimeSecond/60)/5*pi/6)); py21:=yRotate(px20,py20,((FTimeMinute+FTimeSecond/60)/5*pi/6));
        px31:=xRotate(px30,py30,((FTimeMinute+FTimeSecond/60)/5*pi/6)); py31:=yRotate(px30,py30,((FTimeMinute+FTimeSecond/60)/5*pi/6));
        px41:=xRotate(px40,py40,((FTimeMinute+FTimeSecond/60)/5*pi/6)); py41:=yRotate(px40,py40,((FTimeMinute+FTimeSecond/60)/5*pi/6));
        px51:=xRotate(px50,py50,((FTimeMinute+FTimeSecond/60)/5*pi/6)); py51:=yRotate(px50,py50,((FTimeMinute+FTimeSecond/60)/5*pi/6));

        Canvas.Pen.Width:= FWidthBorderLine;
        Canvas.Brush.style := bsClear;
        if FTypeHandsBrush= hbSolid then
        begin
          Canvas.Brush.Color :=clBlack;
          canvas.pie(HalfAdjust(sx+rOuter-(widthHandMinute-widthBorderLine)/2),
                     HalfAdjust(sy+rOuter-(widthHandMinute-widthBorderLine)/2),
                     HalfAdjust(sx+rOuter+(widthHandMinute-widthBorderLine)/2),
                     HalfAdjust(sy+rOuter+(widthHandMinute-widthBorderLine)/2),
                     Halfadjust(sx+px11),
                     Halfadjust(sy+py11),
                     Halfadjust(sx+px51),
                     Halfadjust(sy+py51));
          Canvas.Polygon([point(Halfadjust(sx+px11),Halfadjust(sy+py11)),
                          point(Halfadjust(sx+px21),Halfadjust(sy+py21)),
                          point(Halfadjust(sx+px41),Halfadjust(sy+py41)),
                          point(Halfadjust(sx+px51),Halfadjust(sy+py51))]);
          canvas.pie(HalfAdjust(sx+px31-(widthHandMinute-widthBorderLine)/2),
                     HalfAdjust(sy+py31-(widthHandMinute-widthBorderLine)/2),
                     HalfAdjust(sx+px31+(widthHandMinute-widthBorderLine)/2),
                     HalfAdjust(sy+py31+(widthHandMinute-widthBorderLine)/2),
                     Halfadjust(sx+px41),
                     Halfadjust(sy+py41),
                     Halfadjust(sx+px21),
                     Halfadjust(sy+py21));
        end;
        if FTypeHandsBrush=hbClear then
        begin
          canvas.Arc(HalfAdjust(sx+rOuter-(widthHandMinute-widthBorderLine)/2),
                     HalfAdjust(sy+rOuter-(widthHandMinute-widthBorderLine)/2),
                     HalfAdjust(sx+rOuter+(widthHandMinute-widthBorderLine)/2),
                     HalfAdjust(sy+rOuter+(widthHandMinute-widthBorderLine)/2),
                     Halfadjust(sx+px11),
                     Halfadjust(sy+py11),
                     Halfadjust(sx+px51),
                     Halfadjust(sy+py51));
          Canvas.moveto(Halfadjust(sx+px11),Halfadjust(sy+py11));
          canvas.lineto(Halfadjust(sx+px21),Halfadjust(sy+py21));
          canvas.Arc(HalfAdjust(sx+px31-(widthHandMinute-widthBorderLine)/2),
                     HalfAdjust(sy+py31-(widthHandMinute-widthBorderLine)/2),
                     HalfAdjust(sx+px31+(widthHandMinute-widthBorderLine)/2),
                     HalfAdjust(sy+py31+(widthHandMinute-widthBorderLine)/2),
                     Halfadjust(sx+px41),
                     Halfadjust(sy+py41),
                     Halfadjust(sx+px21),
                     Halfadjust(sy+py21));
          canvas.moveto(Halfadjust(sx+px41),Halfadjust(sy+py41));
          canvas.LineTo(Halfadjust(sx+px51),Halfadjust(sy+py51));
        end;
      end;
    hsSharp:
      begin
        px10:=HalfAdjust( (widthHandMinute-widthBorderLine)/2) ;py10:=HalfAdjust(-(widthHandMinute-widthBorderLine)/2*3);
        px20:=HalfAdjust( (widthHandMinute-widthBorderLine)/2) ;py20:=HalfAdjust(rOuter*RatioMinute-sqrt(1/2)*(widthHandMinute-widthBorderLine));
        px30:=0                                                ;py30:=HalfAdjust(rOuter*RatioMinute);
        px40:=HalfAdjust(-(widthHandMinute-widthBorderLine)/2) ;py40:=HalfAdjust(rOuter*RatioMinute-sqrt(1/2)*(widthHandMinute-widthBorderLine));
        px50:=HalfAdjust(-(widthHandMinute-widthBorderLine)/2) ;py50:=HalfAdjust(-(widthHandMinute-widthBorderLine)/2*3);

        px11:=xRotate(px10,py10,((FTimeMinute+FTimeSecond/60)/5*pi/6)); py11:=yRotate(px10,py10,((FTimeMinute+FTimeSecond/60)/5*pi/6));
        px21:=xRotate(px20,py20,((FTimeMinute+FTimeSecond/60)/5*pi/6)); py21:=yRotate(px20,py20,((FTimeMinute+FTimeSecond/60)/5*pi/6));
        px31:=xRotate(px30,py30,((FTimeMinute+FTimeSecond/60)/5*pi/6)); py31:=yRotate(px30,py30,((FTimeMinute+FTimeSecond/60)/5*pi/6));
        px41:=xRotate(px40,py40,((FTimeMinute+FTimeSecond/60)/5*pi/6)); py41:=yRotate(px40,py40,((FTimeMinute+FTimeSecond/60)/5*pi/6));
        px51:=xRotate(px50,py50,((FTimeMinute+FTimeSecond/60)/5*pi/6)); py51:=yRotate(px50,py50,((FTimeMinute+FTimeSecond/60)/5*pi/6));

        Canvas.Pen.Width:= FWidthBorderLine;
        Canvas.Brush.style := bsClear;
        if FTypeHandsBrush=hbSolid then
        begin
          Canvas.Brush.Color := clBlack ;
          Canvas.Polygon([Point(Halfadjust(sx+px11),Halfadjust(sy+py11)),
                          Point(Halfadjust(sx+px21),Halfadjust(sy+py21)),
                          Point(Halfadjust(sx+px31),Halfadjust(sy+py31)),
                          Point(Halfadjust(sx+px41),Halfadjust(sy+py41)),
                          Point(Halfadjust(sx+px51),Halfadjust(sy+py51))]);
        end;
        if FTypeHandsBrush=hbClear then
        begin
          Canvas.Polygon([Point(Halfadjust(sx+px11),Halfadjust(sy+py11)),
                          Point(Halfadjust(sx+px21),Halfadjust(sy+py21)),
                          Point(Halfadjust(sx+px31),Halfadjust(sy+py31)),
                          Point(Halfadjust(sx+px41),Halfadjust(sy+py41)),
                          Point(Halfadjust(sx+px51),Halfadjust(sy+py51))]);
        end;
      end;
  end;

  //bj
  canvas.Pen.Style:= psSolid;
  canvas.Pen.Color:= clBlue;
  canvas.Pen.Width:=WidthHandSecond;
  if FTypeShowHandSecond=shsShow then
  begin
    canvas.MoveTo(HalfAdjust(sx+(rOuter+rSecond*rOuter*cos(FTimeSecond*2*pi/60+pi/2)/4)),
                  HalfAdjust(sy+(rOuter+rSecond*rOuter*sin(FTimeSecond*2*pi/60+pi/2)/4)));
    canvas.LineTo(HalfAdjust(sx+(rOuter-rSecond*rOuter*cos(FTimeSecond*2*pi/60+pi/2))),
                  HalfAdjust(sy+(rOuter-rSecond*rOuter*sin(FTimeSecond*2*pi/60+pi/2))));
  end;

  //S
  canvas.Pen.Style:= psSolid;
  if FTypeShowHandSecond=shsShow then canvas.Pen.Color:= clblue else canvas.Pen.Color:= clblack;
  canvas.Pen.Width:= WidthBorderLine;
  Canvas.Brush.color := FBoardColor;
  canvas.Brush.Style:= bssolid;
  canvas.Ellipse(HalfAdjust(sx+FDiameter / 2-(FWidthHandMinute / 2)),
                 HalfAdjust(sy+FDiameter / 2-(FWidthHandMinute / 2)),
                 HalfAdjust(sx+FDiameter / 2+(FWidthHandMinute / 2)),
                 HalfAdjust(sy+FDiameter / 2+(FWidthHandMinute / 2)));

  // Ղ̕[]
  canvas.Pen.Color:= clBlack;
  canvas.Pen.Style:= psSolid;
  Canvas.Brush.Style := bsclear;
  Canvas.Font.size:= FBoardFontSizeHour;
  Canvas.Font.Color := clWindowText;
  for i:=1 to 12 do
  begin
    ValueText := inttostr(i);
    //̈ݒ肷
    ValueTextRect := Rect(HalfAdjust(sx+rOuter-(rInner-FBoardFontSizeHour*5/6)*cos(i*pi/6+pi/2)-FBoardFontSizeHour*23/24),
                          HalfAdjust(sy+rOuter-(rInner-FBoardFontSizeHour*5/6)*sin(i*pi/6+pi/2)-FBoardFontSizeHour*2/3),
                          HalfAdjust(sx+rOuter-(rInner-FBoardFontSizeHour*5/6)*cos(i*pi/6+pi/2)+FBoardFontSizeHour*25/24),
                          HalfAdjust(sy+rOuter-(rInner-FBoardFontSizeHour*5/6)*sin(i*pi/6+pi/2)+FBoardFontSizeHour*2/3));
    case FTypeBoardCharacterHour of
      bchNone :begin end;
      bchNoon :if i=12 then           DrawText(Canvas.Handle, PChar(ValueText), -1, ValueTextRect, DT_CENTER or DT_SINGLELINE);
      bchFour :if ((i mod 3)=0)  then DrawText(Canvas.Handle, PChar(ValueText), -1, ValueTextRect, DT_CENTER or DT_SINGLELINE);
      bchAll  :                       DrawText(Canvas.Handle, PChar(ValueText), -1, ValueTextRect, DT_CENTER or DT_SINGLELINE);
    end;
  end;

  // Ղ̕[]
  canvas.Pen.Color:= clBlack;
  canvas.Pen.Style:= psSolid;
  Canvas.Brush.Style := bsclear;
  Canvas.Font.size:= FBoardFontSizeMinute;
  Canvas.Font.Color := clWindowText;

  for i:=0 to 59 do
  begin
    ValueText := inttostr(i);
    //̈ݒ肷
    ValueTextRect := Rect(HalfAdjust(sx+rOuter-(rOuter+FBoardFontSizeMinute*5/6)*cos(i*pi/30+pi/2)-FBoardFontSizeMinute*23/24),
                          HalfAdjust(sy+rOuter-(rOuter+FBoardFontSizeMinute*5/6)*sin(i*pi/30+pi/2)-FBoardFontSizeMinute*2/3),
                          HalfAdjust(sx+rOuter-(rOuter+FBoardFontSizeMinute*5/6)*cos(i*pi/30+pi/2)+FBoardFontSizeMinute*25/24),
                          HalfAdjust(sy+rOuter-(rOuter+FBoardFontSizeMinute*5/6)*sin(i*pi/30+pi/2)+FBoardFontSizeMinute*2/3));
    case FTypeBoardCharacterMinute of
      bcmNone   :begin end;
      bcmFour   :if ((i mod 15)=0) then DrawText(Canvas.Handle, PChar(ValueText), -1, ValueTextRect, DT_CENTER or DT_SINGLELINE);
      bcmTwelve :if ((i mod  5)=0) then DrawText(Canvas.Handle, PChar(ValueText), -1, ValueTextRect, DT_CENTER or DT_SINGLELINE);
      bcmAll    :                       DrawText(Canvas.Handle, PChar(ValueText), -1, ValueTextRect, DT_CENTER or DT_SINGLELINE);
    end;
  end;
end;

procedure TClock.Change;
// OnChangeCxg̃CxgfBXpb`
begin
  if Assigned(FOnChange) then FOnChange(Self);
end;

procedure TClock.Resize;
//Rg[̃TCYύX
begin
  inherited;
  if Height <> FDiameter
  then
  begin
    FDiameter:=Height-3*FBoardFontSizeMinute;
    width := Height;
  end
  else
  begin
    FDiameter:=Width-3*FBoardFontSizeMinute;
    Height:= width;
  end;

  sx:=width/2-FDiameter/2;
  sy:=height/2-FDiameter/2;

  FWidthBorderLine:=HalfAdjust(FDiameter /160);
  FWidthScale1Minutes:=HalfAdjust(FDiameter /160);
  FWidthScale5Minutes:=HalfAdjust(FDiameter /160*2);
  FWidthScaleNoon:=HalfAdjust(FDiameter /160*5);
  FWidthHandHour:=HalfAdjust(FDiameter /160*8);
  FWidthHandMinute:=HalfAdjust(FDiameter /160*5);
  FWidthHandSecond:=HalfAdjust(FDiameter /160);
//  FBoardFontSizeHour:= HalfAdjust(FDiameter /160*13);   R|[lg̑傫ωĂAĘAȂ悤ɂ
//  FBoardFontSizeMinute:= HalfAdjust(FDiameter /160*4);

  Invalidate;
  Change;
end;

procedure TClock.SetTimeHour(const Value: Integer);
// j̈ʒu(l)ύX
var
  NewTimeHour: Integer;
begin
  NewTimeHour := Value;

  NewTimeHour:= NewTimeHour mod 12;

  // Vl(ʒu)O̒lƈقȂȂʒuXVOnChangeCxgN
  if NewTimeHour <> FTimeHour then
  begin
    FTimeHour:= NewTimeHour;
    Invalidate;
    Change;  // OnChangeCxg
  end;
end;

procedure TClock.SetTimeMinute(const Value: Integer);
// j̈ʒu(l)ύX
var
  NewTimeHour: Integer;
  NewTimeMinute: integer;
begin
  NewTimeMinute := Value;
  NewTimeHour:= FTimeHour;

  NewTimeMinute:= NewTimeMinute mod 60;
  NewTimeHour:= NewTimeHour+ (NewTimeMinute div 60);

  // Vl(ʒu)O̒lƈقȂȂʒuXVOnChangeCxgN
  if ((FTimeMinute <> NewTimeMinute) or (FTimeHour <> NewTimeHour)) then
  begin
    FTimeMinute:= NewTimeMinute;
    FTimeHour:= NewTimeHour;
    Invalidate;
    Change;  // OnChangeCxg
  end;
end;

procedure TClock.SetTimeSecond(const Value: Integer);
// ubvύX
var
  NewTimeSecond: Integer;
  NewTimeMinute: Integer;
  NewTimeHour  : Integer;
begin
  NewTimeSecond := Value;
  NewTimeMinute := FTimeMinute;
  NewTimeHour   := FTimeHour;

  NewTimeHour:= (NewTimeHour+ (NewTimeSecond div 3600)) mod 12;
  NewTimeMinute:= (NewTimeMinute + (NewTimeSecond div 60)) mod 60;
  NewTimeSecond:= NewTimeSecond mod 60;

  // Vl(ʒu)O̒lƈقȂȂʒuXVOnChangeCxgN
  if ((FTimeSecond <> NewTimeSecond) or (FTimeMinute <> NewTimeMinute) or (FTimeHour <> NewTimeHour))then
  begin
    FTimeSecond := NewTimeSecond;
    FTimeMinute := NewTimeMinute;
    FTimeHour   := NewTimeHour;
    Invalidate;
    Change;  // OnChangeCxg
  end;
end;

procedure TClock.SetBoardFontSizeHour(const Value: byte);
// Ղ̕[]̃tHgTCYύX
var
  NewBoardFontSizeHour: byte;
begin
  NewBoardFontSizeHour := Value;
  if FBoardFontSizeHour <> NewBoardFontSizeHour then
  begin
    FBoardFontSizeHour := NewBoardFontSizeHour;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetBoardFontSizeMinute(const Value: byte);
// Ղ̕[]̃tHgTCYύX
var
  NewBoardFontSizeMinute: byte;
begin
  NewBoardFontSizeMinute := Value;
  if FBoardFontSizeMinute <> NewBoardFontSizeMinute then
  begin
    FBoardFontSizeMinute := NewBoardFontSizeMinute;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetBoardColor(const Value: TColor);
// Ղ̐FύX
var
  NewBoardColor: Integer;
begin
  NewBoardColor := Value;
  if FBoardColor <> NewBoardColor then
  begin
    FBoardColor := NewBoardColor;

    Invalidate;
    Change;
  end;
end;


procedure TClock.SetWidthBorderLine(const Value: byte);
// ȆύX
var
  NewWidthBorderLine: byte;
begin
  NewWidthBorderLine:= Value;
  if WidthBorderLine <> NewWidthBorderLine then
  begin
    FWidthBorderLine:= NewWidthBorderLine;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetWidthScaleNoon(const Value: byte);
// PQ̂Ƃ̐̑ύX
var
  NewWidthScaleNoon: byte;
begin
  NewWidthScaleNoon:= Value;
  if WidthScaleNoon <> NewWidthScaleNoon then
  begin
    FWidthScaleNoon:= NewWidthScaleNoon;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetWidthScale1Minutes(const Value: byte);
// P݂̐̑ύX
var
  NewWidthScale1Minutes: byte;
begin
  NewWidthScale1Minutes:= Value;
  if WidthScale1Minutes <> NewWidthScale1Minutes then
  begin
    FWidthScale1Minutes:= NewWidthScale1Minutes;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetWidthScale5Minutes(const Value: byte);
// T݂̐̑ύX
var
  NewWidthScale5Minutes: byte;
begin
  NewWidthScale5Minutes:= Value;
  if WidthScale5Minutes <> NewWidthScale5Minutes then
  begin
    FWidthScale5Minutes:= NewWidthScale5Minutes;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetWidthHandMinute(const Value: byte);
// j̑ύX
var
  NewWidthHandMinute: byte;
begin
  NewWidthHandMinute:= Value;
  if WidthHandMinute <> NewWidthHandMinute then
  begin
    FWidthHandMinute:= NewWidthHandMinute;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetWidthHandSecond(const Value: byte);
// bj̑ύX
var
  NewWidthHandSecond: byte;
begin
  NewWidthHandSecond:= Value;
  if WidthHandSecond <> NewWidthHandSecond then
  begin
    FWidthHandSecond:= NewWidthHandSecond;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetWidthHandHour(const Value: byte);
// j̑ύX
var
  NewWidthHandHour: byte;
begin
  NewWidthHandHour:= Value;
  if WidthHandHour <> NewWidthHandHour then
  begin
    FWidthHandHour:= NewWidthHandHour;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetTypeBoardCharacterHour(const Value: TTypeBoardCharacterHour);
//Ղ̕[]\̌^ύX@bchNone:Ȃ; bchNoon:12; bchFore:12,3,6,9; bchAll:ׂĂ
var
  NewTypeBoardCharacterhour: TTypeBoardCharacterHour;
begin
  NewTypeBoardCharacterHour:= value;
  if TypeBoardCharacterHour <> NewTypeBoardCharacterHour then
  begin
    FTypeBoardCharacterHour := Value;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetTypeBoardCharacterHourAssist(const Value: TTypeBoardCharacterHourAssist);
//Ղ̕[]\̌^ύX@bchaHide:Ȃ,bchaShow:
var
  NewTypeBoardCharacterHourAssist: TTypeBoardCharacterHourAssist;
begin
  NewTypeBoardCharacterHourAssist:= value;
  if TypeBoardCharacterHourAssist <> NewTypeBoardCharacterHourAssist then
  begin
    FTypeBoardCharacterHourAssist := Value;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetTypeBoardCharacterMinute(const Value: TTypeBoardCharacterMinute);
//Ղ̕[]\̌^ύX@bcmNone:Ȃ; bcmFore:12,3,6,9; bcmTwelve:êƂ낾; bcmAll:ׂĂ
var
  NewTypeBoardCharacterMinute: TTypeBoardCharacterMinute;
begin
  NewTypeBoardCharacterMinute:= value;
  if TypeBoardCharacterMinute <> NewTypeBoardCharacterMinute then
  begin
    FTypeBoardCharacterMinute := Value;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetTypeBoardScale(const Value: TTypeBoardScale);
//Ղ̍ݕ\̌^ύX bsNoon:݂Ȃ; bsNoon:12̂Ƃ낾; bsFour:3,6,9,12̂Ƃ낾; bsTwelve:êƂ낾; bsAll:ׂĂ
var
  NewTypeBoardScale: TTypeBoardScale;
begin
  NewTypeBoardScale:= value;
  if TypeBoardScale <> NewTypeBoardScale then
  begin
    FTypeBoardScale := Value;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetTypeShowHandSecond(const Value: TTypeShowHandSecond);
//bj\̌^ύX@ssShow:bj; ssHide:\
var
  NewTypeShowHandSecond: TTypeShowHandSecond;
begin
  NewTypeShowHandSecond:= value;
  if TypeShowHandSecond <> NewTypeShowHandSecond then
  begin
    FTypeShowHandSecond := Value;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetTypeDividedColor(const Value: TTypeDividedColor);
//敪Fȟ^ύX@dcYes:; dcNo:Ȃ
var
  NewTypeDividedColor: TTypeDividedColor;
begin
  NewTypeDividedColor:= value;
  if TypeDividedColor <> NewTypeDividedColor then
  begin
    FTypeDividedColor := Value;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetTypeHandsShape(const Value: TTypeHandsShape);
//j`̌^ύX nsRound:; nsSharp:
var
  NewTypeHandsShape: TTypeHandsShape;
begin
  NewTypeHandsShape:= value;
  if TypeHandsShape <> NewTypeHandsShape then
  begin
    FTypeHandsShape := Value;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetTypeHandsBrush(const Value: TTypeHandsBrush);
//jhԂ̌^ύX
var
  NewTypeHandsBrush: TTypeHandsBrush;
begin
  NewTypeHandsBrush:= value;
  if TypeHandsBrush <> NewTypeHandsBrush then
  begin
    FTypeHandsBrush := Value;

    Invalidate;
    Change;
  end;
end;

procedure TClock.SetDiameter(const Value: integer);
// Ղ̒aύX
var
  NewDiameter: Integer;
begin
  NewDiameter := Value;

  // VlO̒lƈقȂȂXVOnChangeCxgN
  if NewDiameter <> FDiameter then
  begin
    FDiameter:= NewDiameter;

    Invalidate;
    Change;  // OnChangeCxg
  end;
end;

end.

