unit UnitClock205WhatTimeIsIt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,printers, Grids, Spin, Clock{..\clock\clock.dcu};

type
  TFormClock205WhatTimeIsIt = class(TForm)
    PrintDialog1: TPrintDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    Label00: TLabel;
    LabelGappiNamae: TLabel;
    Label001: TLabel;
    LabelAnswer1: TLabel;
    LabelAnswer2: TLabel;
    LabelAnswer4: TLabel;
    LabelAnswer3: TLabel;
    LabelAnswer5: TLabel;
    LabelAnswer6: TLabel;
    LabelProjectName: TLabel;
    LabelHyoudai1: TLabel;
    Clock1: TClock;
    Clock2: TClock;
    Clock3: TClock;
    Clock4: TClock;
    Clock5: TClock;
    PanelButtons: TPanel;
    ButtonNew: TButton;
    ButtonStart: TButton;
    ButtonPrinterSetup: TButton;
    ButtonPrintOut: TButton;
    GroupBoxStart: TGroupBox;
    ButtonRadioGroupStartClose: TButton;
    Clock6: TClock;
    StringGrid1: TStringGrid;
    GroupBoxBoard: TGroupBox;
    GroupBoxHands: TGroupBox;
    RadioGroupNeedleShape: TRadioGroup;
    RadioGroupTime: TRadioGroup;
    RadioGroupRandomMinutes: TRadioGroup;
    PanelRange: TPanel;
    LabelRange: TLabel;
    SpinEditStandard: TSpinEdit;
    SpinEditWidth: TSpinEdit;
    GroupBoxCharacter: TGroupBox;
    CheckBoxDividedColor: TCheckBox;
    CheckBoxHourAssist: TCheckBox;
    RadioGroupBoardCharacterHour: TRadioGroup;
    RadioGroupBoardCharacterMinute: TRadioGroup;
    RadioGroupScale: TRadioGroup;
    CheckBoxHandsBrush: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
    procedure ButtonPrintOutClick(Sender: TObject);
    procedure RadioGroupRandomMinutesClick(Sender: TObject);
    procedure EveryMinutes;
    procedure CheckBoxDividedColorClick(Sender: TObject);
    procedure ButtonPrinterSetupClick(Sender: TObject);
    procedure RadioGroupNeedleShapeClick(Sender: TObject);
    procedure RadioGroupHandsBrushClick(Sender: TObject);
    procedure ButtonRadioGroupStartCloseClick(Sender: TObject);
    procedure Renew(Sender: TObject);
    procedure RadioGroupBoardCharacterMinuteClick(Sender: TObject);
    procedure ButtonStartClick(Sender: TObject);
    procedure CheckBoxHourAssistClick(Sender: TObject);
    procedure RadioGroupTimeClick(Sender: TObject);
    procedure RadioGroupBoardCharacterHourClick(Sender: TObject);
    procedure RadioGroupScaleClick(Sender: TObject);
    procedure SpinEditStandardChange(Sender: TObject);
    procedure SpinEditWidthChange(Sender: TObject);
    procedure CheckBoxHandsBrushClick(Sender: TObject);
  private
    { Private 錾 }
    procedure RansuuHassei;
    procedure Re_display;
  public
    { Public 錾 }
  end;

var
  FormClock205WhatTimeIsIt: TFormClock205WhatTimeIsIt;

var hours,minutes:integer;
    PenWidthBorderLine: integer;
    PenWidthScaleNoon: integer;
    PenWidthScale1Minutes: integer;
    PenWidthScale5Minutes: integer;
    PenWidthLongHand: integer;
    PenWidthShortHand: integer;
var px10,py10,px20,py20,px30,py30,px40,py40,px50,py50:integer;
var px11,py11,px21,py21,px31,py31,px41,py41,px51,py51:integer;
var sCheckBoxDividedColor,
    sCheckBoxHourAssist,
    sRadioGroupBoardCharacterHour,
    sRadioGroupBoardCharacterMinute,
    sRadioGroupScale,
    sRadioGroupNeedleShape,
    sRadioGroupHandsBrush,
    sRadioGroupTime,
    sRadioGroupRandomMinutes
    :string;

implementation

{$R *.DFM}
procedure TFormClock205WhatTimeIsIt.Re_display;
begin
  LabelHyoudai1.Caption:= sCheckBoxDividedColor
                        + sCheckBoxHourAssist
                        + sRadioGroupBoardCharacterHour
                        + sRadioGroupBoardCharacterMinute
                        + sRadioGroupScale
                        + sRadioGroupNeedleShape
                        + sRadioGroupHandsBrush
                        + sRadioGroupTime;
end;

procedure TFormClock205WhatTimeIsIt.RansuuHassei;
var i,j: integer;
begin
  randomize;
  for i:=1 to 6 do
    StringGrid1.Cells[i,1]:= inttostr(random(12));
  for i:=1 to 6 do
    case RadioGroupTime.ItemIndex of
      0:case RadioGroupRandomMinutes.ItemIndex of
          0: StringGrid1.Cells[i,2]:= inttostr(0);
          1: StringGrid1.Cells[i,2]:= inttostr(random(2)*30);
          2: StringGrid1.Cells[i,2]:= inttostr(random(3)*20);
          3: StringGrid1.Cells[i,2]:= inttostr(random(4)*15);
          4: StringGrid1.Cells[i,2]:= inttostr(random(6)*10);
          5: StringGrid1.Cells[i,2]:= inttostr(random(12)*5);
          6: StringGrid1.Cells[i,2]:= inttostr(random(60))
          else StringGrid1.Cells[i,2]:= inttostr(0);
        end;
      1:for j:=1 to 6 do StringGrid1.Cells[j,2]:= inttostr(SpinEditStandard.value-random(SpinEditWidth.value*2+1)+SpinEditWidth.value);
    end;

  Clock1.Timehour:= strtoint(stringgrid1.Cells[1,1]);
  Clock2.Timehour:= strtoint(stringgrid1.Cells[2,1]);
  Clock3.Timehour:= strtoint(stringgrid1.Cells[3,1]);
  Clock4.Timehour:= strtoint(stringgrid1.Cells[4,1]);
  Clock5.Timehour:= strtoint(stringgrid1.Cells[5,1]);
  Clock6.Timehour:= strtoint(stringgrid1.Cells[6,1]);

  Clock1.TimeMinute:= strtoint(stringgrid1.Cells[1,2]);
  Clock2.TimeMinute:= strtoint(stringgrid1.Cells[2,2]);
  Clock3.TimeMinute:= strtoint(stringgrid1.Cells[3,2]);
  Clock4.TimeMinute:= strtoint(stringgrid1.Cells[4,2]);
  Clock5.TimeMinute:= strtoint(stringgrid1.Cells[5,2]);
  Clock6.TimeMinute:= strtoint(stringgrid1.Cells[6,2]);
end;

procedure TFormClock205WhatTimeIsIt.FormCreate(Sender: TObject);
var c: integer;
begin
  Color:= clWhite;
  Clock1.BoardColor:= clWhite;
  Clock2.BoardColor:= clWhite;
  Clock3.BoardColor:= clWhite;
  Clock4.BoardColor:= clWhite;
  Clock5.BoardColor:= clWhite;
  Clock6.BoardColor:= clWhite;

  Clock1.TypeShowHandSecond:=shsHide;
  Clock2.TypeShowHandSecond:=shsHide;
  Clock3.TypeShowHandSecond:=shsHide;
  Clock4.TypeShowHandSecond:=shsHide;
  Clock5.TypeShowHandSecond:=shsHide;
  Clock6.TypeShowHandSecond:=shsHide;

  BorderStyle:= bsSizeable;
  PrintScale:= poPrintToFit;
  Scaled:= True;

  PenWidthBorderLine:=1;
  PenWidthScaleNoon:=5;
  PenWidthScale1Minutes:=1;
  PenWidthScale5Minutes:=2;
  PenWidthLongHand:=6;
  PenWidthShortHand:=10;

  CheckBoxDividedColor.checked:=true;
  CheckBoxHourAssist.Checked:=True;
  RadioGroupBoardCharacterHour.ItemIndex:=0;
  RadioGroupBoardCharacterMinute.ItemIndex:=1;
  RadioGroupScale.ItemIndex:=0;
  RadioGroupNeedleShape.ItemIndex:=1;
  CheckBoxHandsBrush.Checked:=true;
  RadioGroupTime.ItemIndex:=0;
  RadioGroupRandomMinutes.ItemIndex:=1;
  Stringgrid1.Hide;
  Stringgrid1.EditorMode:= true;
  StringGrid1.ColWidths[0]:= 36;
  for c:=1 to 4 do stringgrid1.Cells[c,0]:=inttostr(c);
  Stringgrid1.Cells[0, 0]:='';
  StringGrid1.Cells[0, 1]:='';
  StringGrid1.Cells[0, 2]:='';

  renew(sender);
end;

procedure TFormClock205WhatTimeIsIt.FormDblClick(Sender: TObject);
begin
  FormCreate(Sender);
end;

procedure TFormClock205WhatTimeIsIt.ButtonPrinterSetupClick(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TFormClock205WhatTimeIsIt.ButtonPrintOutClick(Sender: TObject);
begin
  GroupBoxStart.Hide;
  PanelButtons.Hide;

  printer.Orientation:= poLandscape;//v^ZbgAbv_CAOʂAڂɉuɐݒ
  Printer.Title:=self.Text;
  Self.Print;

  PanelButtons.show;
  GroupBoxStart.Show;

  renew(sender);
end;

procedure TFormClock205WhatTimeIsIt.RadioGroupRandomMinutesClick(Sender: TObject);
begin
  if RadioGroupTime.ItemIndex=0 then
    case RadioGroupRandomMinutes.ItemIndex of
      0:sRadioGroupTime:='():ʒu, :0';
      1:sRadioGroupTime:='():ʒu, :0,30';
      2:sRadioGroupTime:='():ʒu, :20';
      3:sRadioGroupTime:='():ʒu, :15';
      4:sRadioGroupTime:='():ʒu, :10';
      5:sRadioGroupTime:='():ʒu, :5';
      6:sRadioGroupTime:='():ʒu, :1';
    end;
  re_display;
  renew(sender);
end;

procedure TFormClock205WhatTimeIsIt.RadioGroupNeedleShapeClick(Sender: TObject);
begin
  if RadioGroupNeedleShape.ItemIndex=0 then
  begin
    Clock1.TypeHandsShape:= hsRound;
    Clock2.TypeHandsShape:= hsRound;
    Clock3.TypeHandsShape:= hsRound;
    Clock4.TypeHandsShape:= hsRound;
    Clock5.TypeHandsShape:= hsRound;
    Clock6.TypeHandsShape:= hsRound;
    sRadioGroupNeedleShape:='j:,';
  end
  else
  begin
    Clock1.TypeHandsShape:= hssharp;
    Clock2.TypeHandsShape:= hssharp;
    Clock3.TypeHandsShape:= hssharp;
    Clock4.TypeHandsShape:= hssharp;
    Clock5.TypeHandsShape:= hssharp;
    Clock6.TypeHandsShape:= hssharp;
    sRadioGroupNeedleShape:='j:,';
  end;
  Re_display;
end;

procedure TFormClock205WhatTimeIsIt.CheckBoxDividedColorClick(Sender: TObject);
begin
  if CheckBoxDividedColor.checked=true
  then
  begin
    Clock1.TypeDividedColor:= dcYes;
    Clock2.TypeDividedColor:= dcYes;
    Clock3.TypeDividedColor:= dcYes;
    Clock4.TypeDividedColor:= dcYes;
    Clock5.TypeDividedColor:= dcYes;
    Clock6.TypeDividedColor:= dcYes;
    sCheckBoxDividedColor:='Fh:, '
  end
  else
  begin
    Clock1.TypeDividedColor:= dcNo;
    Clock2.TypeDividedColor:= dcNo;
    Clock3.TypeDividedColor:= dcNo;
    Clock4.TypeDividedColor:= dcNo;
    Clock5.TypeDividedColor:= dcNo;
    Clock6.TypeDividedColor:= dcNo;
    CheckBoxHourAssist.Checked:=false;
    sCheckBoxDividedColor:='Fh:Ȃ, '
  end;
  Re_Display;
end;

procedure TFormClock205WhatTimeIsIt.EveryMinutes;
begin
  hours:= random(12);
  case RadioGroupRandomMinutes.ItemIndex of
    0: minutes:= 0;
    1: minutes:= random(2)*30;
    2: minutes:= random(3)*20;
    3: minutes:= random(4)*15;
    4: minutes:= random(6)*10;
    5: minutes:= random(12)*5;
    6: minutes:= random(60)
    else minutes:= 0;
  end;
end;
procedure TFormClock205WhatTimeIsIt.RadioGroupHandsBrushClick(Sender: TObject);
begin
  if CheckBoxHandsBrush.checked=True then
  begin
    Clock1.TypeHandsBrush:= hbSolid;
    Clock2.TypeHandsBrush:= hbSolid;
    Clock3.TypeHandsBrush:= hbSolid;
    Clock4.TypeHandsBrush:= hbSolid;
    Clock5.TypeHandsBrush:= hbSolid;
    Clock6.TypeHandsBrush:= hbSolid;
    sRadioGroupHandsBrush:= 'hԂ, ';
  end
  else
  begin
    Clock1.TypeHandsBrush:= hbClear;
    Clock2.TypeHandsBrush:= hbClear;
    Clock3.TypeHandsBrush:= hbClear;
    Clock4.TypeHandsBrush:= hbClear;
    Clock5.TypeHandsBrush:= hbClear;
    Clock6.TypeHandsBrush:= hbClear;
    sRadioGroupHandsBrush:= ', ';
  end;
  Re_display;
end;

procedure TFormClock205WhatTimeIsIt.ButtonRadioGroupStartCloseClick(Sender: TObject);
begin
  GroupBoxStart.hide;
end;

procedure TFormClock205WhatTimeIsIt.Renew(Sender: TObject);
begin
  //l
  ransuuHassei;
  LabelProjectName.caption:= 'Clock205WhatTimeIsIt.exe';
end;

procedure TFormClock205WhatTimeIsIt.RadioGroupBoardCharacterMinuteClick(Sender: TObject);
begin
  case RadioGroupBoardCharacterMinute.ItemIndex of
    0:begin
        clock1.TypeBoardCharacterMinute:= bcmAll;
        clock2.TypeBoardCharacterMinute:= bcmAll;
        clock3.TypeBoardCharacterMinute:= bcmAll;
        clock4.TypeBoardCharacterMinute:= bcmAll;
        clock5.TypeBoardCharacterMinute:= bcmAll;
        clock6.TypeBoardCharacterMinute:= bcmAll;
        sRadioGroupBoardCharacterMinute:='̐:Sĕ\, ';
      end;
    1:begin
        clock1.TypeBoardCharacterMinute:= bcmTwelve;
        clock2.TypeBoardCharacterMinute:= bcmTwelve;
        clock3.TypeBoardCharacterMinute:= bcmTwelve;
        clock4.TypeBoardCharacterMinute:= bcmTwelve;
        clock5.TypeBoardCharacterMinute:= bcmTwelve;
        clock6.TypeBoardCharacterMinute:= bcmTwelve;
        sRadioGroupBoardCharacterMinute:='̐:5ŕ\, ';
      end;
    2:begin
        clock1.TypeBoardCharacterMinute:= bcmFour;
        clock2.TypeBoardCharacterMinute:= bcmFour;
        clock3.TypeBoardCharacterMinute:= bcmFour;
        clock4.TypeBoardCharacterMinute:= bcmFour;
        clock5.TypeBoardCharacterMinute:= bcmFour;
        clock6.TypeBoardCharacterMinute:= bcmFour;
        sRadioGroupBoardCharacterMinute:='̐:15ŕ\, ';
      end;
    3:begin
        clock1.TypeBoardCharacterMinute:= bcmNone;
        clock2.TypeBoardCharacterMinute:= bcmNone;
        clock3.TypeBoardCharacterMinute:= bcmNone;
        clock4.TypeBoardCharacterMinute:= bcmNone;
        clock5.TypeBoardCharacterMinute:= bcmNone;
        clock6.TypeBoardCharacterMinute:= bcmNone;
        sRadioGroupBoardCharacterMinute:='̐:\, ';
      end;
  end;
  Re_display;
end;

procedure TFormClock205WhatTimeIsIt.ButtonStartClick(Sender: TObject);
begin
  GroupBoxStart.show;
end;

procedure TFormClock205WhatTimeIsIt.CheckBoxHourAssistClick(Sender: TObject);
begin
  if CheckBoxHourAssist.Checked=true
  then
  begin
    Clock1.TypeDividedColor:=dcYes; Clock1.TypeBoardCharacterHour:=bchAll; Clock1.TypeBoardCharacterHourAssist:=bchaShow; Clock1.TypeBoardScale:=bsAll;
    Clock2.TypeDividedColor:=dcYes; Clock2.TypeBoardCharacterHour:=bchAll; Clock2.TypeBoardCharacterHourAssist:=bchaShow; Clock2.TypeBoardScale:=bsAll;
    Clock3.TypeDividedColor:=dcYes; Clock3.TypeBoardCharacterHour:=bchAll; Clock3.TypeBoardCharacterHourAssist:=bchaShow; Clock3.TypeBoardScale:=bsAll;
    Clock4.TypeDividedColor:=dcYes; Clock4.TypeBoardCharacterHour:=bchAll; Clock4.TypeBoardCharacterHourAssist:=bchaShow; Clock4.TypeBoardScale:=bsAll;
    Clock5.TypeDividedColor:=dcYes; Clock5.TypeBoardCharacterHour:=bchAll; Clock5.TypeBoardCharacterHourAssist:=bchaShow; Clock5.TypeBoardScale:=bsAll;
    Clock6.TypeDividedColor:=dcYes; Clock6.TypeBoardCharacterHour:=bchAll; Clock6.TypeBoardCharacterHourAssist:=bchaShow; Clock6.TypeBoardScale:=bsAll;
    CheckBoxDividedColor.Checked:=true;
    if CheckBoxDividedColor.checked=true then sCheckBoxHourAssist:='⏕:\, ';
  end
  else
  begin
    Clock1.TypeBoardCharacterHourAssist:=bchaHide;
    Clock2.TypeBoardCharacterHourAssist:=bchaHide;
    Clock3.TypeBoardCharacterHourAssist:=bchaHide;
    Clock4.TypeBoardCharacterHourAssist:=bchaHide;
    Clock5.TypeBoardCharacterHourAssist:=bchaHide;
    Clock6.TypeBoardCharacterHourAssist:=bchaHide;
    sCheckBoxHourAssist:='⏕:\, ';
  end;
  Re_Display;
end;

procedure TFormClock205WhatTimeIsIt.RadioGroupTimeClick(Sender: TObject);
begin
  case RadioGroupTime.ItemIndex of
    0:begin
        RadioGroupRandomMinutes.Enabled:=true;
        SpinEditStandard.Enabled:=false;
        SpinEditWidth.Enabled:=false;
        LabelRange.Enabled:=false;
        case RadioGroupRandomMinutes.ItemIndex of
          0:sRadioGroupTime:='():ʒu, :0';
          1:sRadioGroupTime:='():ʒu, :0,30';
          2:sRadioGroupTime:='():ʒu, :20';
          3:sRadioGroupTime:='():ʒu, :15';
          4:sRadioGroupTime:='():ʒu, :10';
          5:sRadioGroupTime:='():ʒu, :5';
          6:sRadioGroupTime:='():ʒu, :1';
        end;
      end;
    1:begin
        RadioGroupRandomMinutes.Enabled:=false;
        SpinEditStandard.Enabled:=true;
        SpinEditWidth.Enabled:=true;
        LabelRange.Enabled:=true;
        SpinEditStandard.SetFocus;
        sRadioGroupTime:='():͈:'+inttostr(spinEditStandard.Value)+'}'+ inttostr(SpinEditWidth.value)+'';
      end;
  end;
  renew(sender);
  Re_display;
end;

procedure TFormClock205WhatTimeIsIt.RadioGroupBoardCharacterHourClick(Sender: TObject);
begin
  if RadioGroupBoardCharacterHour.ItemIndex<>0 then CheckBoxDividedColor.Checked:= false;
  case RadioGroupBoardCharacterHour.ItemIndex of
    0:begin
        Clock1.TypeBoardCharacterHour:=bchAll;
        Clock2.TypeBoardCharacterHour:=bchAll;
        Clock3.TypeBoardCharacterHour:=bchAll;
        Clock4.TypeBoardCharacterHour:=bchAll;
        Clock5.TypeBoardCharacterHour:=bchAll;
        Clock6.TypeBoardCharacterHour:=bchAll;
        sRadioGroupBoardCharacterHour:='̐:Sĕ\, ';
      end;
    1:begin
        Clock1.TypeBoardCharacterHour:=bchFour;
        Clock2.TypeBoardCharacterHour:=bchFour;
        Clock3.TypeBoardCharacterHour:=bchFour;
        Clock4.TypeBoardCharacterHour:=bchFour;
        Clock5.TypeBoardCharacterHour:=bchFour;
        Clock6.TypeBoardCharacterHour:=bchFour;
        sRadioGroupBoardCharacterHour:='̐:3,6,9,12̂ݕ\, ';
      end;
    2:begin
        Clock1.TypeBoardCharacterHour:=bchNoon;
        Clock2.TypeBoardCharacterHour:=bchNoon;
        Clock3.TypeBoardCharacterHour:=bchNoon;
        Clock4.TypeBoardCharacterHour:=bchNoon;
        Clock5.TypeBoardCharacterHour:=bchNoon;
        Clock6.TypeBoardCharacterHour:=bchNoon;
        sRadioGroupBoardCharacterHour:='̐:12̂ݕ\, ';
      end;
    3:begin
        Clock1.TypeBoardCharacterHour:=bchNone;
        Clock2.TypeBoardCharacterHour:=bchNone;
        Clock3.TypeBoardCharacterHour:=bchNone;
        Clock4.TypeBoardCharacterHour:=bchNone;
        Clock5.TypeBoardCharacterHour:=bchNone;
        Clock6.TypeBoardCharacterHour:=bchNone;
        sRadioGroupBoardCharacterHour:='̐:\, ';
      end;
  end;
  Re_display;
end;

procedure TFormClock205WhatTimeIsIt.RadioGroupScaleClick(Sender: TObject);
begin
  case RadioGroupScale.ItemIndex of
    0:begin
        Clock1.TypeBoardScale:=bsAll;
        Clock2.TypeBoardScale:=bsAll;
        Clock3.TypeBoardScale:=bsAll;
        Clock4.TypeBoardScale:=bsAll;
        Clock5.TypeBoardScale:=bsAll;
        Clock6.TypeBoardScale:=bsAll;
        sRadioGroupScale:='ڐ:S, ';
      end;
    1:begin
        Clock1.TypeBoardScale:=bsTwelve;
        Clock2.TypeBoardScale:=bsTwelve;
        Clock3.TypeBoardScale:=bsTwelve;
        Clock4.TypeBoardScale:=bsTwelve;
        Clock5.TypeBoardScale:=bsTwelve;
        Clock6.TypeBoardScale:=bsTwelve;
        sRadioGroupScale:='ڐ:5, ';
      end;
    2:begin
        Clock1.TypeBoardScale:=bsFour;
        Clock2.TypeBoardScale:=bsFour;
        Clock3.TypeBoardScale:=bsFour;
        Clock4.TypeBoardScale:=bsFour;
        Clock5.TypeBoardScale:=bsFour;
        Clock6.TypeBoardScale:=bsFour;
        sRadioGroupScale:='ڐ:15, ';
      end;
    3:begin
        Clock1.TypeBoardScale:=bsNone;
        Clock2.TypeBoardScale:=bsNone;
        Clock3.TypeBoardScale:=bsNone;
        Clock4.TypeBoardScale:=bsNone;
        Clock5.TypeBoardScale:=bsNone;
        Clock6.TypeBoardScale:=bsNone;
        sRadioGroupScale:='ڐ:\, ';
      end;
  end;
  Re_display;
end;

procedure TFormClock205WhatTimeIsIt.SpinEditStandardChange(Sender: TObject);
begin
  sRadioGroupTime:='():͈:'+inttostr(spinEditStandard.Value)+'}'+ inttostr(SpinEditWidth.value)+'';
  Re_display;
  renew(sender);
end;

procedure TFormClock205WhatTimeIsIt.SpinEditWidthChange(Sender: TObject);
begin
  sRadioGroupTime:='():͈:'+inttostr(spinEditStandard.Value)+'}'+ inttostr(SpinEditWidth.value)+'';
  Re_display;
  renew(sender);
end;

procedure TFormClock205WhatTimeIsIt.CheckBoxHandsBrushClick(
  Sender: TObject);
begin
  if CheckBoxHandsBrush.checked=true then
  begin
    Clock1.TypeHandsBrush:= hbSolid;
    Clock2.TypeHandsBrush:= hbSolid;
    Clock3.TypeHandsBrush:= hbSolid;
    Clock4.TypeHandsBrush:= hbSolid;
    Clock5.TypeHandsBrush:= hbSolid;
    Clock6.TypeHandsBrush:= hbSolid;
  end
  else
  begin
    Clock1.TypeHandsBrush:= hbClear;
    Clock2.TypeHandsBrush:= hbClear;
    Clock3.TypeHandsBrush:= hbClear;
    Clock4.TypeHandsBrush:= hbClear;
    Clock5.TypeHandsBrush:= hbClear;
    Clock6.TypeHandsBrush:= hbClear;
  end;
end;

end.
